#ifndef __INPUTVIEW_H__
#define __INPUTVIEW_H__

class InputView : public BView
{
public:
	InputView(BRect rect, BWindow *front);
	virtual ~InputView();
	enum {
		UP, DOWN, LEFT, RIGHT, BUTTON1, BUTTON2, START, MAX
	};
	virtual void Pulse();
	virtual void Draw(BRect updateRect);
	virtual void AttachedToWindow();
	virtual void KeyDown(const char *bytes, int32 numbytes);
	virtual void MessageReceived(BMessage *m);
	virtual void SetInput(bool doinput) { input = doinput; }
	virtual bool IsInput() const { return input; }
	virtual void ChangeLabel(int index, int key);
	virtual void SetKeys(uint8 *which);
private:
	BWindow *front;
	BStringView *sview;
	int key;
	int input_num;
	bool input;
	BBitmap *tile_bitmap;
	BStringView *input_sviews[MAX];
	BBox *box;
	uint8 *which;
};

#endif