#include "smsjoystick.h"
#include <string.h>

Joystick::Joystick()
	: BJoystick()
{
	memset(rgbbuttons, 0, sizeof(rgbbuttons));
	memset(axes, 0, sizeof(axes));
	v_axes = false;
}

uint8 Joystick::Pressed(int which)
{
	return(rgbbuttons[which]);
}

bool Joystick::Up()
{
	if(v_axes) return axes[1] > 16384;
	return axes[1] < -16384;
}

bool Joystick::Down()
{
	if(v_axes) return axes[1] < -16384;
	return axes[1] > 16384;
}

bool Joystick::Left()
{
	return axes[0] < -16384;
}

bool Joystick::Right()
{
	return axes[0] > 16384;
}

int16 Joystick::AxisX()
{
	return axes[0];
}

int16 Joystick::AxisY()
{
	return axes[1];
}

status_t Joystick::Update()
{
	status_t status = BJoystick::Update();
	
	if(status == B_NO_ERROR) {
		GetAxisValues(axes);
		uint32 buttons = ButtonValues();
		for(int i = 0; i < MAX_BUTTONS; i++)
			rgbbuttons[i] = buttons & (1 << i) ? 1 : 0;
	}
	return(status);
}

void Joystick::SwapVerticalAxes(bool really)
{
	v_axes = really;
}

void Joystick::SwapHorizontalAxes(bool really)
{
}