#ifndef __SMS_SOUNDPLAYER_H__
#define __SMS_SOUNDPLAYER_H__

#include <string.h>
#include <SoundPlayer.h>
#include <Locker.h>

class SmsSoundPlayer : public BSoundPlayer
{
public:
	SmsSoundPlayer(
				const media_raw_audio_format * format, 
				const char * name = NULL);
	virtual ~SmsSoundPlayer();
	static void callback(void *cookie, void *buffer, size_t len, const media_raw_audio_format &format);
	virtual void InitAll(int sub_buffer_size);
	virtual void WriteBufferSync(short *data, int len);
	virtual void ResetAll(bool value);
	virtual void Lock();
	virtual void Unlock();
private:
	BLocker locker;
	uint8 *sub_buffer;
	int read_buffer, write_buffer, audio_len;
};

#endif
