#include <String.h>
#include "system_menu_bar.h"
#include "system_beos_constants.h"


GameMenuBar::GameMenuBar(BRect frame, const char *title)
	: BMenuBar(frame, title)
{
	// Game Menu
	BMenu *game_menu = new BMenu("Game");
	game_menu->AddItem(new BMenuItem("Load Rom", new BMessage('open'), 'O'));
	game_menu->AddSeparatorItem();
	game_menu->AddItem(new BMenuItem("Soft Reset", new BMessage(ID_GAME_SOFT_RESET)));
	game_menu->AddItem(new BMenuItem("Hard Reset", new BMessage(ID_GAME_HARD_RESET)));
	game_menu->AddSeparatorItem();
	
	BMenu *save_menu = new BMenu("Save State");
	for(int i = 0; i < 5; i++)
	{
		BMessage *msg = new BMessage(ID_SAVE_STATE);
		BString item_name;
		
		item_name << "Slot " << i+1;
		msg->AddInt32("save_slot", i);
		
		save_menu->AddItem(new BMenuItem(item_name.String(), msg));
	}
	game_menu->AddItem(save_menu);
	
	BMenu *load_menu = new BMenu("Load State");
	for(int i = 0; i < 5; i++)
	{
		BMessage *msg = new BMessage(ID_LOAD_STATE);
		BString item_name;
		
		item_name << "Slot " << i+1;
		msg->AddInt32("load_slot", i);
		
		load_menu->AddItem(new BMenuItem(item_name.String(), msg));
	}
	game_menu->AddItem(load_menu);
	
	game_menu->AddSeparatorItem();
	game_menu->AddItem(new BMenuItem("Exit", new BMessage(ID_GAME_EXIT), 'Q'));
	AddItem(game_menu);
	
	// Options Menu
	BMenu *options = new BMenu("Options");
	AddItem(options);
	
	// Options->Sound
	BMenu *sound_menu = new BMenu("Sound");
	sound_menu->AddItem(new BMenuItem("Mute", new BMessage(ID_OPTIONS_MUTE)));
	options->AddItem(sound_menu);
	
	// options->Graphics
	BMenu *graphics_menu = new BMenu("Graphics");
	graphics_menu->SetRadioMode(true);
	graphics_menu->AddItem(new BMenuItem("1x_mode", new BMessage(ID_OPTIONS_SPECIAL_MODE0)));
	graphics_menu->AddSeparatorItem();
	graphics_menu->AddItem(new BMenuItem("2x_double_mode", new BMessage(ID_OPTIONS_SPECIAL_MODE1)));
	graphics_menu->AddItem(new BMenuItem("2x_standard_scanlines", new BMessage(ID_OPTIONS_SPECIAL_MODE2)));
	graphics_menu->AddItem(new BMenuItem("2x_lcd_mode", new BMessage(ID_OPTIONS_SPECIAL_MODE3)));
	graphics_menu->AddItem(new BMenuItem("2xSaI(FullScreen)", new BMessage(ID_OPTIONS_SPECIAL_MODE4)));
	graphics_menu->AddItem(new BMenuItem("Super2xSaI(FullScreen)", new BMessage(ID_OPTIONS_SPECIAL_MODE5)));
	graphics_menu->AddItem(new BMenuItem("SuperEagle(FullScreen)", new BMessage(ID_OPTIONS_SPECIAL_MODE6)));
	
	options->AddItem(graphics_menu);
	
	options->AddSeparatorItem();
	
	// Options->Controls
	BMenu *controls_menu = new BMenu("Controls");
	controls_menu->AddItem(new BMenuItem("KeyBoard 0", new BMessage(ID_LAUNCH_KEYBOARD0)));
	controls_menu->AddItem(new BMenuItem("KeyBoard 1", new BMessage(ID_LAUNCH_KEYBOARD1)));
	controls_menu->AddItem(new BMenuItem("Joystick 0", new BMessage(ID_LAUNCH_JOYSTICK0)));
	controls_menu->AddItem(new BMenuItem("Joystick 1", new BMessage(ID_LAUNCH_JOYSTICK1)));
	options->AddItem(controls_menu);
	
	// Options->Other
	BMenu *other_menu = new BMenu("Other");
	other_menu->AddItem(new BMenuItem("Refresh Rate", new BMessage(ID_LAUNCH_REFRESH)));
	options->AddItem(other_menu);
	
	options->AddSeparatorItem();
	options->AddItem(new BMenuItem("Log Audio", new BMessage(ID_LOG_AUDIO)));
	options->AddItem(new BMenuItem("FullScreen", new BMessage('full')));
	
	BMenu *help = new BMenu("Help");
	help->AddItem(new BMenuItem("About SmsPlus", new BMessage(ID_HELP_ABOUTSMSPLUS)));
	AddItem(help);
}
